(defun C:Z20 (/		 10ER	    11ER       ANZAHL	  BSCALE_ERROR
	      CMD_ALT	 EDATEN	    ERROR_ALT  INDEX	  LETZTER
	      O_CLASS	 SGET	    TEMP_LAENGE		  TEMP_LISTE
	      TXT	 WRT	    ALT_KORD   EL	  ENAME
	      NEU_KORD
	     )
  (defun BSCALE_ERROR (MSG)
    (princ MSG)
    (setq *ERROR* ERROR_ALT
	  ERROR_ALT NIL
    ) ;_ end setq
    (princ
      (strcat
	"Fehler! AutoCAD meldet \""
	MSG
	"\" als Ursache.\nFehlerbehandlung setzt nderungen zurck!"
      ) ;_ end strcat
    ) ;_ end princ
    (command "_.undo" "_b")
    (princ)
  ) ;_ end defun
  (setq	ERROR_ALT *ERROR*
	*ERROR*	  BSCALE_ERROR
	CMD_ALT	  (getvar "cmdecho")
  ) ;_ end setq
  (command "_.undo" "_m")
  (setvar "cmdecho" 0)
  (command "_.ucs" "_w")
  (princ "\nZ - Koordinaten auf auf Hhe 0.00 setzen...")
  (princ "\nWhlen Sie die Objekte aus...")
  (setq	SGET   (ssget)
	ANZAHL (sslength SGET)
	INDEX  0
  ) ;_ end setq
  (while (< INDEX ANZAHL)
    (setq EDATEN  (entget (ssname SGET INDEX))
	  O_CLASS (cdr (assoc 0 EDATEN))
	  ENAME (cdr (assoc -1 EDATEN))
    ) ;_ end setq
    (princ (strcat "\rBearbeite Objekt Nr.:"
		   (itoa INDEX)
		   " von: "
		   (itoa ANZAHL)
		   " ausgewhlten Objekten..."
	   ) ;_ end strcat
    ) ;_ end princ
    (cond ((= O_CLASS "LINE")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	   (setq 11ER	 (assoc 11 EDATEN)
		 LETZTER (last 11ER)
		 11ER	 (subst 0.0 LETZTER 11ER)
		 EDATEN	 (subst 11ER (assoc 11 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "INSERT")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "ARC")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "TEXT")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "CIRCLE")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "ELLIPSE")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "POINT")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "SHAPE")
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   ) ;_ end setq
	   (entmod EDATEN)
	  )
	  ((= O_CLASS "POLYLINE")	   
	   (while
	     (and (setq ENAME (entnext ENAME))
		  (= (cdr (assoc 0 (setq EL (entget ENAME)))) "VERTEX")
	     ) ;_ end and
	      (setq ALT_KORD (assoc 10 EL)
		    NEU_KORD (cons
			       10
			       (reverse	(cons 0.0 (cdr (reverse (cdr ALT_KORD))))
			       ) ;_ end reverse
			     ) ;_ end cons
		    EL	     (subst NEU_KORD ALT_KORD EL)
	      ) ;_ end setq
	      (entmod EL)
	   ) ;_ end while
	   (setq 10ER	 (assoc 10 EDATEN)
		 LETZTER (last 10ER)
		 10ER	 (subst 0.0 LETZTER 10ER)
		 EDATEN	 (subst 10ER (assoc 10 EDATEN) EDATEN)
	   )
	   (entmod edaten)
	  )
	  (t
	   (if (null TEMP_LISTE)
	     (setq TEMP_LISTE '()) ;_ end setq
	   ) ;_ end if
	   (if (= (member O_CLASS TEMP_LISTE) NIL)
	     (setq TEMP_LISTE (append (list O_CLASS) TEMP_LISTE))
	   ) ;_ end if
	  )
    ) ;_ end cond
    (setq INDEX (1+ INDEX))
  ) ;_ end while
  (setq TEMP_LAENGE (length TEMP_LISTE))
  (repeat TEMP_LAENGE
    (setq WRT	     (car TEMP_LISTE)
	  TEMP_LISTE (cdr TEMP_LISTE)
    ) ;_ end setq
    (if	(null TXT)
      (setq TXT "Folgende Objektklassen wurden NICHT bearbeitet:\n")
    ) ;_ end if
    (setq TXT (strcat TXT WRT "\n"))
  ) ;_ end repeat
  (if TXT
    (alert TXT)
  ) ;_ end if
  (command "_ucs" "_p")
  (setvar "cmdecho" CMD_ALT)
  (setq *ERROR* ERROR_ALT)
  (princ "\nAlles klar, Programm beendet !")
  (princ)
) ;_ end defun


(defun C:Z_TO_TXT (/ ANZAHL EDATEN INDEX KORD SGET TS TXT_INS ZKORD)
  (command "_ucs" "_w")
  (princ
    "\nObjekte whlen. Blcke werden herausgefiltert...   "
  ) ;_ end princ
  (setq	SGET   (ssget '((0 . "insert")))
	ANZAHL (sslength SGET)
	INDEX  0
  ) ;_ end setq
  (while (< INDEX ANZAHL)
    (setq EDATEN  (entget (ssname SGET INDEX))
	  KORD	  (assoc 10 EDATEN)
	  ZKORD	  (rtos (last KORD) 2 2)
	  TXT_INS (list (nth 1 KORD) (nth 2 KORD))
	  TS	  (tblsearch "LAYER" "Ermittelte_hoehen")
    ) ;_ end setq
    (if	(null TS)
      (progn (alert "\nLayer nicht vorhanden!\nErstelle automatisch...")
	     (command "_layer"	   "_m"		"Ermittelte_hoehen"
		      "_c"	   "3"		""
		      "_l"	   "continuous"	""
		      ""
		     ) ;_ end command
 ;_ end command
      ) ;_ end progn
      (command "_layer"
	       "_thaw"
	       "Ermittelte_hoehen"
	       "_on"
	       "Ermittelte_hoehen"
	       ""
      ) ;_ end command
    ) ;_ end if
    (command "_.text" TXT_INS "0.9" "100" ZKORD)
    (setq INDEX (1+ INDEX))
  ) ;_ end while
  (princ (strcat "\nAlles klar, "
		 (itoa ANZAHL)
		 " Hhentexte erzeugt !"
	 ) ;_ end strcat
  ) ;_ end princ
  (princ)
) ;_ end defun


(defun C:OBJEKTE (/	    ANZAHL    EDATEN	INDEX	  O_CLASS
		  SGET	    TEMP_LAENGE		TEMP_LISTE
		  TXT	    WRT
		 )
  (setq	SGET   (ssget "X")
	ANZAHL (sslength SGET)
	INDEX  0
  ) ;_ end setq
  (while (< INDEX ANZAHL)
    (setq EDATEN  (entget (ssname SGET INDEX))
	  O_CLASS (cdr (assoc 0 EDATEN))
    ) ;_ end setq
    (if	(null TEMP_LISTE)
      (setq TEMP_LISTE '())
    ) ;_ end if
    (if	(= (member O_CLASS TEMP_LISTE) NIL)
      (setq TEMP_LISTE (append (list O_CLASS) TEMP_LISTE))
    ) ;_ end if
    (setq INDEX (1+ INDEX))
  ) ;_ end while
  (setq TEMP_LAENGE (length TEMP_LISTE))
  (repeat TEMP_LAENGE
    (setq WRT	     (car TEMP_LISTE)
	  TEMP_LISTE (cdr TEMP_LISTE)
    ) ;_ end setq
    (if	(null TXT)
      (setq TXT "Diese Zeichnung enthlt folgende Objekttypen:\n")
    ) ;_ end if
    (setq TXT (strcat TXT WRT "\n"))
  ) ;_ end repeat
  (alert TXT)
  (princ)
) ;_ end defun


(princ
  "\nZ20.lsp...\(C\)1999 Marc Scherer\nAufruf mit \"Z20\", \"Z_TO_TXT\", \"OBJEKTE\"!"
) ;_ end princ
(princ)
