;;; -----------------------------------------------------------------
;;; franz@ploetzl.at  Vienna/Austria             www.ploetzl.at/tools 
;;; A-1050 Wien       Hartmanngassse 13/4/36 tel +43 (0)1   5456702
;;; A-4100 Ottensheim Holzweg        5       fax +43 (0)732 771250 12
;;--------------------------------------------------------------------
; ZBASIS.LSP
;
; ndert z-basiskoordinaten auf angegeben wert
; nicht jedoch die z-koordinaten von 
; TRACE, 3DFACE, SOLIDS 
; AUFRUF: ZBASIS
;
; pf 1191 ver11/0.1
; pf 0395 ver12,13/1.0
; pf 0598 rel14/1.1 lwpolyline, mtext, mline, dim, ellipse, image
;                   leader, solid, tolerance, 3dface

;;; 11.05.2000 Einbau einer Funktion, die auch Standard Plines bearbeitet
;;; by Marc Scherer

;----------------------------------------------------------------
(alert
(strcat
"\nDiese Programme sind dem OpenSourceKonzept verschrieben."
"\nWas mit den Programmen, ausser dem Benutzen selbst, erlaubt ist:"
"\nWeitergeben an Dritte, uneingeschrnkt Modifikation des Quelltextes"
"\n(SourceCode), bzw. Weiterverwendung von Teilen oder des gesamten"
"\nQuelltextets in Software Dritter unter Einhaltung des 'CopyLefts'."
;
 "\nEinen Einschrnkung gibt es doch:"
"\nGanz umsonst mchte ich unsere TOOLS nicht hergebn."
"\nWenn Sie mit einem Programm von uns zufrieden sind und dieses auch"
"\nin Ihrem Betrieb, Unternehmen, etc. einsetzen, sind Sie verpflichtet"
"\nfr jedes Tool einen angemessener Betrag"
"\nvon 100 bis 500 ATS / 15 bis 70 DM / 10 bis 50 $ oder auch mehr"
"\nfr 'Soziale Projekte' oder 'Einrichtungen' zu spenden!"
;
"\nUnd wer sich nicht daran hlt - den hole der Teufel!"))
; so long and don't be square be doome - franz pltzl
;----------------------------------------------------------------------
;  ENITY-CHNAGE
;  elemnte modifizieren
;  benoetigte daten: elementdaten - enityliste (entget (car (entsel)))     
;                    neuer wert 
;                    enity code
;
;  aufruf: (enity-change element neu code)    pf0391 ver10.0/1.0
;----------------------------------------------------------------------
(defun ENITY-CHANGE (ELEMENT NEU CODE / ALT LISTE)
  (setq ENITY-ALT (cdr (assoc CODE ELEMENT)))
  (setq ALT (assoc CODE ELEMENT))
  (setq LISTE (cons CODE NEU))
  (entmod (setq ELEMENT (subst LISTE ALT ELEMENT)))
  (setq NEW ELEMENT)
) ;_ end defun


					;wenn xyz punkt
(defun EH_WORK (ENT NR)
  (setq EH_XYZ (cdr (assoc NR ENT)))
  (if (/= EH_Z_NEU (caddr EH_XYZ))
    (progn (setq EH_NEU (list (car EH_XYZ) (cadr EH_XYZ) EH_Z_NEU))
	   (ENITY-CHANGE ENT EH_NEU NR)
	   (setq EH_ENITY NEW)
	   (setq EH_AEND (+ EH_AEND 1))
    )					;progn
  )					;if  
) ;_ end defun
(defun EH_ERROR	()
  (setq EH_FEHLER (+ EH_FEHLER 1))
  (prompt "N")
) ;_ end defun
					;--------------
					; hauptprogramm
					;---------------
(defun C:ZBASIS	(/	   EH_ERH    EH_Z_NEU  EH_SEL	 EH_ANZ
		 EH_ANTW   10ER	     ALT_KORD  EDATEN	 EL
		 ENAME	   LETZTER   NEU_KORD
		)
;;;nderung von Marc Scherer Weltkoordinatensystem
  (command "_.ucs" "_w")
  (setq	TXT
	 (strcat
	   "\nndern der Z-Koordinaten.  pfSpecial 1.2\n"
	   "\nVorsicht: Alle Z-Basiskoordinaten werden auf den angegeben Wert gesetz!"
	   "\nErfat nicht: 3DSolids, Regionen."
	   "\nAlle Z-Koord. von 3DFlchen, Bnder, Solids werden gendert."
	 ) ;_ end strcat
  ) ;_ end setq
  (alert TXT)
  (setq EH_ERH (getvar "elevation"))
  (princ "\nndern auf Z-Koordinate: <")
  (princ EH_ERH)
  (princ "> ")
  (setq EH_ANTW (getreal))
  (if (= EH_ANTW NIL)
    (setq EH_Z_NEU EH_ERH)
    (setq EH_Z_NEU EH_ANTW)
  ) ;_ end if
  (setq EH_SEL (ssget))
  (if (/= EH_SEL NIL)
    (progn
      (setq EH_ANZ (sslength EH_SEL))
      (prompt (strcat (itoa EH_ANZ) " Elemente gewhlt."))
      (prompt "\nBearbeite Element ")
      (setq EH_ZAE 0
	    EH_FEHLER 0
	    EH_AEND 0
      ) ;_ end setq
      (repeat EH_ANZ
	(setq EH_ENITY (ssname EH_SEL EH_ZAE))
	(setq EH_ENITY (entget EH_ENITY))
	(prompt ".")
	(cond
	  ((= (cdr (assoc 0 EH_ENITY)) "POINT") (EH_WORK EH_ENITY 10))
					;point
	  ((= (cdr (assoc 0 EH_ENITY)) "LINE")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	  )				;line
	  ((= (cdr (assoc 0 EH_ENITY)) "ARC")
	   (EH_WORK EH_ENITY 10)	   
	  )				;arc
	  ((= (cdr (assoc 0 EH_ENITY)) "CIRCLE")
	   (EH_WORK EH_ENITY 10)
	  )				;circle
;;;          ((= (cdr (assoc 0 eh_enity)) "POLYLINE")
;;;            (eh_work eh_enity 10)
;;;          );polyline
	  ((= (cdr (assoc 0 EH_ENITY)) "LWPOLYLINE")
	   (if (/= EH_Z_NEU (cdr (assoc 38 EH_ENITY)))
	     (progn (ENITY-CHANGE EH_ENITY EH_Z_NEU 38)
		    (setq EH_AEND (+ EH_AEND 1))
	     )				;progn
	   )				;if
	  )				;polyline
 ;_ Polyline Function eingebaut 11.05.2000 by Marc Scherer
 ;_ (Dirty Style, i know...)
	  ((= (cdr (assoc 0 EH_ENITY)) "POLYLINE")
	    (setq ENAME (cdr (assoc -1 EH_ENITY)))
	    (while
	      (and (setq ENAME (entnext ENAME))
		   (= (cdr (assoc 0 (setq EL (entget ENAME)))) "VERTEX")
	      ) ;_ end and
	       (setq ALT_KORD (assoc 10 EL)
		     NEU_KORD (cons
				10
				(reverse (cons EH_Z_NEU
					       (cdr (reverse (cdr ALT_KORD)))
					 ) ;_ end cons
				) ;_ end reverse
			      ) ;_ end cons
		     EL	      (subst NEU_KORD ALT_KORD EL)
	       ) ;_ end setq
	       (entmod EL)
	    ) ;_ end while
	    (setq 10ER	   (assoc 10 EH_ENITY)
		  LETZTER  (last 10ER)
		  10ER	   (subst EH_Z_NEU LETZTER 10ER)
		  EH_ENITY (subst 10ER (assoc 10 EH_ENITY) EH_ENITY)
	    ) ;_ end setq
	    (entmod EH_ENITY)
	    (setq EH_AEND (+ EH_AEND 1))
	  ) ;_ end Dirty Style
	  ((= (cdr (assoc 0 EH_ENITY)) "INSERT")
	   (EH_WORK EH_ENITY 10)
	  )				;insert
	  ((= (cdr (assoc 0 EH_ENITY)) "ATTDEF")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	  )				;attdef
	  ((= (cdr (assoc 0 EH_ENITY)) "ATTRIB")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	  )				;attrib
	  ((= (cdr (assoc 0 EH_ENITY)) "TEXT")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	  )				;text
	  ((= (cdr (assoc 0 EH_ENITY)) "MTEXT") (EH_WORK EH_ENITY 10))
					;mtext
	  ((= (cdr (assoc 0 EH_ENITY)) "MLINE") (EH_WORK EH_ENITY 10))
					;mline
	  ((= (cdr (assoc 0 EH_ENITY)) "ELLIPSE")
	   (EH_WORK EH_ENITY 10)
	  )				;ellipse
	  ((= (cdr (assoc 0 EH_ENITY)) "HATCH") (EH_WORK EH_ENITY 10))
					;hatch
	  ((= (cdr (assoc 0 EH_ENITY)) "IMAGE") (EH_WORK EH_ENITY 10))
					;image
	  ((= (cdr (assoc 0 EH_ENITY)) "TOLERANCE")
	   (EH_WORK EH_ENITY 10)
	  )				;tolerance
	  ((= (cdr (assoc 0 EH_ENITY)) "LEADER")
	   (EH_WORK EH_ENITY 10)
	  )				;leader
	  ((= (cdr (assoc 0 EH_ENITY)) "DIMENSION")
	   (EH_WORK EH_ENITY 10)
	   (if (cdr (assoc 11 EH_ENITY))
	     (EH_WORK EH_ENITY 11)
	   ) ;_ end if
	   (if (cdr (assoc 12 EH_ENITY))
	     (EH_WORK EH_ENITY 12)
	   ) ;_ end if
	   (if (cdr (assoc 13 EH_ENITY))
	     (EH_WORK EH_ENITY 13)
	   ) ;_ end if
	   (if (cdr (assoc 14 EH_ENITY))
	     (EH_WORK EH_ENITY 14)
	   ) ;_ end if
	   (if (cdr (assoc 15 EH_ENITY))
	     (EH_WORK EH_ENITY 15)
	   ) ;_ end if
	   (if (cdr (assoc 16 EH_ENITY))
	     (EH_WORK EH_ENITY 16)
	   ) ;_ end if
	  )				;dim
	  ((= (cdr (assoc 0 EH_ENITY)) "SOLID")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	   (EH_WORK EH_ENITY 12)
	   (if (cdr (assoc 13 EH_ENITY))
	     (EH_WORK EH_ENITY 13)
	   ) ;_ end if
	  )				;solid
	  ((= (cdr (assoc 0 EH_ENITY)) "3DFACE")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	   (EH_WORK EH_ENITY 12)
	   (if (cdr (assoc 13 EH_ENITY))
	     (EH_WORK EH_ENITY 13)
	   ) ;_ end if
	  )				;3dface
	  ((= (cdr (assoc 0 EH_ENITY)) "TRACE")
	   (EH_WORK EH_ENITY 10)
	   (EH_WORK EH_ENITY 11)
	   (EH_WORK EH_ENITY 12)
	   (if (cdr (assoc 13 EH_ENITY))
	     (EH_WORK EH_ENITY 13)
	   ) ;_ end if
	  )				;trace
	  ((= (cdr (assoc 0 EH_ENITY)) "SHAPE") (EH_WORK EH_ENITY 10))
					;shape
	  ((= (cdr (assoc 0 EH_ENITY)) "3DFACE") (EH_ERROR)) ;3dface
	  ((= (cdr (assoc 0 EH_ENITY)) "TRACE") (EH_ERROR)) ;3dpoly
	  ((= (cdr (assoc 0 EH_ENITY)) "SOLID") (EH_ERROR)) ;3dpoly
	  ('t (EH_ERROR))
	)				;cond
	(setq EH_ZAE (+ 1 EH_ZAE))
      )					;repeat
    )					;progn
  )					;if
  (prompt (strcat "\nVon "
		  (itoa EH_ANZ)
		  " Elementen "
		  (itoa EH_AEND)
		  " geaendert, "
		  (itoa EH_FEHLER)
		  " nicht bearbeitet."
	  ) ;_ end strcat
  ) ;_ end prompt
  (princ)
)					;defun 

(prompt
  "\nZBASIS.LSP geladen. Befehl aufrufen mit ZBASIS. 0395/0598pf"
) ;_ end prompt
(princ)
